SystemOrganization addCategory: #RPSS!

WAComponent subclass: #RPSS_Main
	instanceVariableNames: 'system administrator page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_Main class methodsFor: 'testing' stamp: 'BogatchevOleg 10/16/2011 13:21'!
canBeRoot
	^true.! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 12:56'!
currentUser
	^ RPSS_System uniqueInstance getUserWithEmail: self session visitor email! !

!RPSS_Main methodsFor: 'initialization' stamp: 'TimLenertz 10/25/2011 12:56'!
initialize 
	super initialize.
	system := RPSS_System uniqueInstance.
	system isInitialized 
	ifFalse: 
	[
		administrator := RPSS_Administrator new.
	].
	page := nil.
	! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 10:30'!
renderContentOn: html
		html div class: #header; with: [self renderHeader: html].
		html div class: #menu; with: [self renderMenu: html].
		html div class: #main; with: [self renderMain: html].
		html div class: #footer; with: [self renderFooter:html].! !

!RPSS_Main methodsFor: 'rendering' stamp: 'BogatchevOleg 10/18/2011 20:50'!
renderFirstAdministrator: html
	html form: 
	[
		html paragraph: 'Your e-mail adress:'.
		html textInput callback: [ :value | administrator email: value ].
		html paragraph: 'Your password:'.
		html textInput
			type: 'password';
			callback: [ :value | administrator password: value ].
		html break.
		html paragraph: 'Email confirmation'.
		html checkbox
			value: true;
			callback: [ :value | administrator confirmEmail: value ].
		html break.
		html paragraph: 'Email confirmation of every new user'.
		html checkbox
			value: true;
			callback: [ :value | system userApprovedByAdmin: value ].
		html break.
		html submitButton
			callback: [ administrator create: html];
			value: 'Initialize!!'
	]! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 10:54'!
renderFooter: html
	html text: ''.! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 12:56'!
renderHeader: html
	html heading: 'RolePlay Support System'.
	self session visitor isLogedIn ifTrue: [html text: 'Logged in as ', self session visitor email] ifFalse: [].! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 12:57'!
renderMain: html
	system isInitialized 
	ifTrue: 
	[
		self session visitor message = ''
		ifTrue: 
		[
			self session visitor module = nil
			ifTrue: 
			[
				html paragraph: 'Welcome to RPSS by group 9, system is ready'.
				html paragraph: 'Please login or create a new user'.
			]
			ifFalse: 
			[	
				html render: self session visitor module.
			].
		]
		ifFalse: 
		[
			self renderMessage: html.
		].	
	]
	ifFalse: 
	[
		html paragraph: 'System is not yet initialized, please input the administrator data'.
		self renderFirstAdministrator: html.
	].! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 14:08'!
renderMenu: html
	self session visitor isLogedIn 
	ifTrue: 
	[
			html paragraph: [html anchor callback: [self session visitor setModule: RPSS_CharClassList new]; with: 'Character Classes'].
			self session visitor isAdministrator 
			ifTrue: 
			[
				html paragraph: [html anchor callback: [self session visitor setModule: RPSS_AdminPanel new. self session visitor module setPage:'approvals']; with: 'Pending approvals'].
			]
			ifFalse: 
			[
		
			].
			html paragraph: [html anchor callback: [self session visitor setModule: RPSS_UserPage new. self session visitor module setPage: 'personal']; with: 'Personal data'].
			html paragraph: [html anchor callback: [self session visitor logout]; with: 'Logout']..
	]
	ifFalse: 
	[
		html paragraph: [html anchor callback: [self session visitor setModule: self session visitor.]; with: 'Login'].
		html paragraph: [html anchor callback: [self session visitor setModule: RPSS_UserCreation new]; with: 'Register'].
	].
! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 12:59'!
renderMessage:html
	html paragraph: 'System message: ', self session visitor message.
	self session visitor setMessage: ''.! !

!RPSS_Main methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 12:13'!
style 
	^ '
.header {
	height: 100px;
	width: 100%;
	position: relative;
	vertical-align: top;
}
.menu {
	width: 100px;
	position: relative;
	float: left;
	left: 0px;
	top: 0px;
}
.footer{
	width: 100%;
	position: static;
	vertical-align: bottom;
	clear: both;
	float: none;
	height: 100px;
}
.main {
	position: relative;
	float: left;
	left: 0px;
	top: 0px;
}'! !

WAComponent subclass: #RPSS_SiteModule
	instanceVariableNames: 'visitor page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_SiteModule subclass: #RPSS_AdminPanel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_AdminPanel methodsFor: 'initialization' stamp: 'BogatchevOleg 10/21/2011 22:40'!
initialize 
	super initialize.
	page := 'approvals'.! !

!RPSS_AdminPanel methodsFor: 'rendering' stamp: 'BogatchevOleg 10/21/2011 23:02'!
renderContentOn: html
	|system|
	system := RPSS_System uniqueInstance.
	html paragraph: 'New users waiting to be approved:'.
	RPSS_System uniqueInstance usersToApprove do: [ :user |
	html form: [
		html text: user email.
		html submitButton value: 'Approve'; callback: [system approveUser: user email].
		html submitButton value: 'Deny'; callback: [system denyUser: user email].
		html break.
	]
]! !

RPSS_SiteModule subclass: #RPSS_CharClassActionEditor
	instanceVariableNames: 'action characterClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_CharClassActionEditor methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:38'!
action
	action ifNil: [action := RPSS_CharacterClassAction new].
	^ action! !

!RPSS_CharClassActionEditor methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:37'!
action: anObject
	action := anObject! !

!RPSS_CharClassActionEditor methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:38'!
characterClass
	^ characterClass! !

!RPSS_CharClassActionEditor methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:38'!
characterClass: anObject
	characterClass := anObject! !

!RPSS_CharClassActionEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/26/2011 01:54'!
renderContentOn: html
	| tempPrereq |
	tempPrereq := RPSS_CharacterClassActionPrerequisite new.
	html paragraph: 'Actions Editor'; break.
	html form: [
		html submitButton value: 'Save'; callback: [self answer: true].
		html cancelButton value: 'Cancel'; callback: [self answer: false].
		html break; break.
		
		html text: 'Dice sides: '.
		html textInput on: #proba of: self action.
		html break. 
		
		html text: 'Duration: '.
		html textInput on: #duration of: self action.
		html text: 'Duration unit: '.
		html select
			list: #(#Minutes #Hours #Turns);
			selected: self action durationType;
			callback: [ :value | self action durationType: value].
		html break. 
		
		html text: 'Prerequisites: '.
		html select
			list: self characterClass inheritedAttributeNames;
			callback: [ :value | self action prerequisites add: value->tempPrereq].
		html select
			list: #(#> #< #= #<= #>=);
			callback: [ :value | tempPrereq sign: value].
		html textInput on: #prerequisiteValue of: tempPrereq.
		html break. 
		
		html text: 'Delay: '.
		html textInput on: #actionDelay of: self action.
		html break. 
		
		html text: 'Trigger: '.
		html select
			list: #();
			selected: self action trigger;
			callback: [ :value | self action trigger value].
		html break. 
		
		html text: 'Cooldown: '.
		html textInput on: #cooldown of: self action.
		html break. 
		
		].! !

RPSS_SiteModule subclass: #RPSS_CharClassAttributeEditor
	instanceVariableNames: 'attribute characterClass tempFormula tempMaxFormula'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_CharClassAttributeEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 23:45'!
attribute
	^ attribute! !

!RPSS_CharClassAttributeEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 23:34'!
attribute: anObject
	attribute := anObject.
	tempFormula := attribute formula copy.
	tempMaxFormula := attribute maximumFormula copy.! !

!RPSS_CharClassAttributeEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 17:54'!
characterClass
	^ characterClass! !

!RPSS_CharClassAttributeEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 17:54'!
characterClass: anObject
	characterClass := anObject! !

!RPSS_CharClassAttributeEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 22:15'!
chooseAttribute
	^ self chooseFrom: (self characterClass attributeNames) caption: 'Please choose an attribute here.'.! !

!RPSS_CharClassAttributeEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 21:38'!
operatorsMenu: operator on: html
	|list|
	list := OrderedCollection new.
	list add: '+'; add: '-'; add: '*'; add: '/'; add: '^'; add: 'min'; add: 'max'.
	^ html select
		list: list;
		selected: operator
		! !

!RPSS_CharClassAttributeEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 23:51'!
renderContentOn: html
	html paragraph: 'Attribute Editor'; break.
	html form: [
		html submitButton value: 'Save'; callback: [self attribute formula: tempFormula. self attribute maximumFormula: tempMaxFormula. self answer: true].
		html cancelButton value: 'Cancel'; callback: [self answer: false].
		html break; break.
		
		html text: 'Collection: '.
		html textInput value: (self attribute collection); callback: [:value | self attribute collection: value].
		html break; break.
		
		html text: 'Initial value: '.
		html textInput value: (self attribute initialValue); callback: [:value | self attribute initialValue: value].
		html break.
		html text: '(If not set, then players will have to define a value on character creation.)'; break; break.
		
		html text: 'Minimum: '.
		html textInput value: (self attribute minValue); callback: [:value | self attribute minValue: value].
		html break.
		
		html text: 'Maximum: '.
		html textInput value: (self attribute maxValue); callback: [:value | self attribute maxValue: value].
		html break.		
		
		html text: 'Can be modified by player: '.
		html checkbox value: (self attribute modifiable); callback: [:value | self attribute modifiable: value].
		html break.
		
		html text: 'Takes random values: '.
		html checkbox value: (self attribute random); callback: [:value | self attribute random: value].
		html break; break.
		
		html text: 'Dynamic value: '; break.
		(tempFormula = nil) ifTrue: [
			html text: 'not defined'.
			html button value: 'Set'; callback: [tempFormula := RPSS_Formula new]
		] ifFalse: [
			self renderFormulaEditor: tempFormula on: html.
			html button value: 'Remove'; callback: [tempFormula := nil]
		].
		html break; break.
		
		html text: 'Dynamic maximum value: '; break.
		(tempMaxFormula = nil) ifTrue: [
			html text: 'not defined'.
			html button value: 'Set'; callback: [tempMaxFormula := RPSS_Formula new]
		] ifFalse: [
			self renderFormulaEditor: tempMaxFormula on: html.
			html button value: 'Remove'; callback: [tempMaxFormula := nil]
		].
	]! !

!RPSS_CharClassAttributeEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 23:18'!
renderFormulaEditor: formula on: html
	(formula operator = nil) ifFalse: [
		html text: '('; break.
		html div
			style: 'margin-left: 25px; border-left: 1px solid gray';
			with: [
				self renderFormulaEditor: (formula operand1) on: html.
				
				html div
					style: 'margin-left: 20px; margin-top: 10px; margin-bottom: 10px';
					with: [(self operatorsMenu: (formula operator) on: html) callback: [:value | formula operator: value]].
				
				self renderFormulaEditor: (formula operand2) on: html.	
			].
		html text: ') '.
		html button value: '><'; callback: [formula contract].
	] ifTrue: [
		html textInput value: (formula operand1); size: 5; callback: [:value | formula operand1: value].
		html button value: '<>'; callback: [formula expand].
		html button value: '...'; callback: [formula operand1: self chooseAttribute].
	] ! !

RPSS_SiteModule subclass: #RPSS_CharClassEditor
	instanceVariableNames: 'characterClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_CharClassEditor methodsFor: 'as yet unclassified' stamp: 'GeoffreyJacquet 10/26/2011 00:38'!
addAction: name
	|editor|
	name ifNotNil: [
		editor := RPSS_CharClassActionEditor new.
		editor characterClass: characterClass.
		(self call: editor) ifTrue: [
			characterClass actions at: name put: (editor action)
		] ifFalse: [].	
	]! !

!RPSS_CharClassEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 23:45'!
addAttribute: name collection: collection
	|editor|
	name ifNotNil: [
		editor := RPSS_CharClassAttributeEditor new.
		editor attribute: RPSS_CharacterClassAttribute new.
		editor attribute collection: collection.
		editor characterClass: characterClass.
		(self call: editor) ifTrue: [
			characterClass attributes at: name put: (editor attribute)
		] ifFalse: [].	
	]! !

!RPSS_CharClassEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:24'!
characterClass
	characterClass ifNil: [characterClass := RPSS_CharacterClass new].
	^ characterClass! !

!RPSS_CharClassEditor methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:21'!
characterClass: anObject
	characterClass := anObject! !

!RPSS_CharClassEditor methodsFor: 'as yet unclassified' stamp: 'GeoffreyJacquet 10/26/2011 00:39'!
modifyAction: actionName
	|object editor|
	object := characterClass actions at: actionName.
	editor := RPSS_CharClassActionEditor new.
	editor characterClass: characterClass.
	editor action: (characterClass actions at: actionName).
	^ self call: editor! !

!RPSS_CharClassEditor methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 18:22'!
modifyAttribute: attributeName
	|object editor|
	object := characterClass attributes at: attributeName.
	editor := RPSS_CharClassAttributeEditor new.
	editor characterClass: characterClass.
	editor attribute: (characterClass attributes at: attributeName).
	^ self call: editor! !

!RPSS_CharClassEditor methodsFor: 'as yet unclassified' stamp: 'GeoffreyJacquet 10/26/2011 00:41'!
renderContentOn: html
	html paragraph: 'Character class editor'.
	html form: [
		html submitButton value: 'Save'; callback: [self answer: true].
		html cancelButton value: 'Cancel'; callback: [self answer: false].
		html break; break.
		
		html text: 'Title: '.
		html textInput value: self characterClass title; callback: [:value | self characterClass title: value].
		html break; break.
		
		html text: 'Attributes:'; break.
		html button value: 'Add new collection'; callback: [
			|collection name|
			collection := (self request: 'Name for new collection?').
			name := (self request: 'Name for new attribute?').
			self addAttribute: name collection: collection.
		].


		self characterClass attributeCollections do: [:collection |
				html break; break.
				html strong: 'Collection: '; strong: collection; text: ' '.
				html button value: 'Add Attribute'; callback: [self addAttribute: (self request: 'Name for new attribute?') collection: collection].
				html break.
				
				self characterClass attributesFromCollection: collection do: [:name :attribute |
					html text: name.
					html button value: 'Modify'; callback: [self modifyAttribute: name].
					html button value: 'Remove'; callback: [self characterClass attributes removeKey: name].
					html break.
				].
			].
		
		html break.
		
		html text: 'Actions:'; break.
		html button value: 'Add Action'; callback: [self addAction: (self request: 'Name for new action?')].
		
		self characterClass actions keysDo: [ :action |
			html break.
			html text: action.
			html button value: 'Modify'; callback: [self modifyAction: action].
			html button value: 'Remove'; callback: [self characterClass actions removeKey: action].
		].
	].! !

RPSS_SiteModule subclass: #RPSS_CharClassList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 14:39'!
addCharacterClass
	|editor|
	editor := RPSS_CharClassEditor new.
	(self call: editor) ifTrue: [
		self session user characterClasses add: editor characterClass
	] ifFalse: [].! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/26/2011 01:53'!
duplicateCharacterClass: class
	|editor newClass|
	editor := RPSS_CharClassEditor new.
	newClass := class copy.
	newClass title: (class title, ' copy').
	editor characterClass: newClass.
	(self call: editor) ifTrue: [
		self session user characterClasses add: editor characterClass
	] ifFalse: [].! !

!RPSS_CharClassList methodsFor: 'initialization' stamp: 'BogatchevOleg 10/24/2011 14:40'!
initialize 
	super initialize.! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 14:32'!
modifyCharacterClass: characterClass
	|editor|
	editor := RPSS_CharClassEditor new.
	editor characterClass: characterClass.
	self call: editor.! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/25/2011 14:31'!
removeCharacterClass: characterClass
	self session user characterClasses remove: characterClass ifAbsent: [].! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/26/2011 01:52'!
renderBranch: parentClass on: html
	html div
		style: 'margin-left: 25px; border-left: 1px solid gray';
		with: [
			self session user characterClasses do: [:class |
				(class parent = parentClass) ifTrue: [
					html text: class title.
					html button value: 'Remove'; callback: [self removeCharacterClass: class].
					html button value: 'Modify'; callback: [self modifyCharacterClass: class].
					html button value: 'Duplicate'; callback: [self duplicateCharacterClass: class].
					html button value: 'Subclass'; callback: [self subclassCharacterClass: class].
					self renderBranch: class on: html.
				] ifFalse: []
			]
		]! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/26/2011 01:53'!
renderContentOn: html
	html paragraph: 'Character classes:'.
	html form: [
		html button value: 'Add'; callback: [self addCharacterClass].
		self renderBranch: nil on: html. 
	]
	! !

!RPSS_CharClassList methodsFor: 'rendering' stamp: 'TimLenertz 10/26/2011 01:53'!
subclassCharacterClass: class
	|editor newClass|
	editor := RPSS_CharClassEditor new.
	newClass := RPSS_CharacterClass new.
	newClass parent: class.
	newClass title: ('Kind of ', class title).
	editor characterClass: newClass.
	(self call: editor) ifTrue: [
		self session user characterClasses add: editor characterClass
	] ifFalse: [].! !

!RPSS_SiteModule methodsFor: 'initialization' stamp: 'TimLenertz 10/25/2011 12:59'!
initialize
	super initialize.
	visitor := self session visitor.! !

!RPSS_SiteModule methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:39'!
setPage: aPage
	page := aPage.! !

RPSS_SiteModule subclass: #RPSS_UserCreation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_UserCreation methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:48'!
confirmCreation: anEmail with: html
	|system user urlApp urlDen|	
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: anEmail.
	user markEmailConfirmed.
	system isUserApprovedByAdmin
	ifTrue: 
	[
		urlApp := html actionUrl copy.
		urlApp addField: (html callbacks store: (WAActionCallback on: [ system approveUser: anEmail ])).
		urlDen := html actionUrl copy.
		urlDen addField: (html callbacks store: (WAActionCallback on: [ system denyUser: anEmail ])).
		(RPSS_MailSender uniqueInstance) sendApprovalToAdmin: urlApp and: urlDen for: anEmail. 
	]
	ifFalse:
	[
		user approveByAdministrator.
	].
	visitor setMessage: 'User approved'.
	! !

!RPSS_UserCreation methodsFor: 'services' stamp: 'BogatchevOleg 10/20/2011 23:40'!
confirmEmail: anEmail
	|system user|	
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: anEmail.
	user markEmailConfirmed.
	page := 'emailConfirm'.! !

!RPSS_UserCreation methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:46'!
create: html
	|system url mail newUser|
	system := RPSS_System uniqueInstance.
	mail := RPSS_MailSender uniqueInstance.
	url := html actionUrl copy.
	url addField: (html callbacks store: (WAActionCallback on: [ self confirmEmail: visitor email ])).
	(system verifyPassword: visitor password) & (system verifyEmail: visitor email)
	ifTrue: 
	[
		(system isEmailOccupied: visitor email)
		ifFalse: 
		[
			newUser := RPSS_User new.
			newUser fromVisitor: visitor.
			system addUser: newUser.
			mail sendEmailConfirmationTo: visitor email withUrl: url.
			visitor setMessage: 'Please confirm your email!!'.
		]
		ifTrue: 
		[
			visitor setMessage: 'This email is already taken!!'.
		].
	]
	ifFalse: 
	[
		visitor setMessage: 'Wrong email or password!!'.
	].! !

!RPSS_UserCreation methodsFor: 'initialization' stamp: 'BogatchevOleg 10/20/2011 23:13'!
initialize 
	super initialize.
	page := 'RegisterForm'.! !

!RPSS_UserCreation methodsFor: 'rendering' stamp: 'BogatchevOleg 10/20/2011 23:33'!
renderContentOn: html
	page = 'RegisterForm'
	ifTrue:
	[
		self renderRegistrationForm: html.
	].
	page = 'emailConfirm'
	ifTrue: 
	[
		self renderEmailConfirmation: html.
	]! !

!RPSS_UserCreation methodsFor: 'rendering' stamp: 'BogatchevOleg 10/20/2011 23:30'!
renderEmailConfirmation: html
	|system|
	system := RPSS_System uniqueInstance.	
	html paragraph: 'Thank you for confirming your email'.
	system userApprovedByAdmin 
	ifTrue: 
	[
		self confirmCreation: visitor email with: html. 
	
	
		html paragraph: 'Administrator will approve your registration shortly'.
	].! !

!RPSS_UserCreation methodsFor: 'rendering' stamp: 'BogatchevOleg 10/20/2011 23:34'!
renderRegistrationForm: html
	html form: 
	[
		html paragraph: 'Your e-mail adress:'.
		html textInput callback: [ :value | visitor email: value ].
		html paragraph: 'Your password:'.
		html textInput
			type: 'password';
			callback: [ :value | visitor password: value ].
		html break.
		html submitButton
			callback: [ self create: html];
			value: 'Register!!'
	].! !

RPSS_SiteModule subclass: #RPSS_UserPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:55'!
changeEmail: html
	|system mail url|
	mail := RPSS_MailSender uniqueInstance.
	system := RPSS_System uniqueInstance.
	((system verifyEmail: visitor tempEmail) &  ((system isEmailOccupied: visitor tempEmail) not))
	ifTrue:
	[
		url := html actionUrl copy.
		url addField: (html callbacks store: (WAActionCallback on: [ self confirmEmailChange: visitor tempEmail ])).
		mail sendEmailChangeTo: visitor email with: visitor tempEmail url: url.
	].
	visitor setMessage: 'You will receive a confirmation email with a link to confirm your change.'.! !

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 18:23'!
changePassword: html
	|system mail url|
	mail := RPSS_MailSender uniqueInstance.
	system := RPSS_System uniqueInstance.
	(system verifyPassword: visitor tempPassword)
	ifTrue:
	[
		url := html actionUrl copy.
		url addField: (html callbacks store: (WAActionCallback on: [ self confirmPasswordChange: visitor tempPassword])).
		mail sendPasswordChangeTo: visitor email url: url.
	].
	visitor setMessage: 'You will receive a confirmation email with a link to confirm your change.'.! !

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 17:09'!
confirmEmailChange: aNewEmail
	|system user|
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: visitor email.
	system transferUserFrom: user email to: aNewEmail. 
	visitor setMessage: 'You successfuly changed your email'.! !

!RPSS_UserPage methodsFor: 'services' stamp: 'BogatchevOleg 10/22/2011 18:18'!
confirmPasswordChange: aNewPassword
	|system user|
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: visitor email.
	user password: aNewPassword.
	visitor setMessage: 'You successfuly changed your password'.! !

!RPSS_UserPage methodsFor: 'initialization' stamp: 'BogatchevOleg 10/21/2011 16:26'!
initialize 
	super initialize.
	page := 'overview'.! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 16:40'!
renderChangeEmail: html
	html paragraph: 'Please input your new email'.
	html form: 
	[
		html textInput callback: [:value | visitor tempEmail: value].
		html break.
		html submitButton callback: [self changeEmail: html.]; value: 'Modify!!'.
	].! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 18:25'!
renderChangePassword: html
	html paragraph: 'Please input your new password'.
	html form: 
	[
		html textInput type: 'password'; callback: [:value | visitor tempPassword: value].
		html break.
		html submitButton callback: [self changePassword: html.]; value: 'Modify!!'.
	].! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 12:19'!
renderContentOn: html
	page = 'overview'
	ifTrue: 
	[
		html paragraph: 'Overview'.
	].
	page = 'personal'
	ifTrue: 
	[
		self renderPersonal: html.
	].
	page = 'changePassword'
	ifTrue:  
	[
		self renderChangePassword: html.
	].
	page = 'changeEmail'
	ifTrue: 
	[
		self renderChangeEmail: html.
	].! !

!RPSS_UserPage methodsFor: 'rendering' stamp: 'BogatchevOleg 10/22/2011 15:34'!
renderPersonal: html
	html paragraph: [html anchor callback: [page := 'changeEmail']; with: 'Change email'].
	html paragraph: [html anchor callback: [page := 'changePassword']; with: 'Change password'].! !

WAComponent subclass: #RPSS_Visitor
	instanceVariableNames: 'email administrator password confirmEmail message logedIn module tempEmail tempPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_Visitor subclass: #RPSS_Administrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_Administrator methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/19/2011 20:03'!
confirmCreation
	|system newAdmin|
	system := RPSS_System uniqueInstance.
	(system isEmailOccupied: email)
	ifFalse: 
	[
		newAdmin := RPSS_User new.
		newAdmin email: email.
		newAdmin password: password.
		newAdmin markEmailConfirmed.
		newAdmin markAsAdministrator.
		newAdmin approveByAdministrator.
		system addUser: newAdmin.
		system finishInitialization.
		system setFirstAdministrator: newAdmin.
	]
	ifTrue: 
	[
		message := 'emailOccupied'.
	].
! !

!RPSS_Administrator methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/22/2011 17:43'!
create: html
	|system url mail|
	system := RPSS_System uniqueInstance.
	mail := RPSS_MailSender uniqueInstance.
	url := html actionUrl copy.
	url addField: (html callbacks store: (WAActionCallback on: [ self confirmCreation ])).
	(system verifyPassword: password) & (system verifyEmail: email)
	ifTrue: 
	[
		mail sendEmailConfirmationTo: email withUrl: url.
	].
	self setMessage: 'Please confirm your email.'.
	! !

!RPSS_Administrator methodsFor: 'initialization' stamp: 'BogatchevOleg 10/17/2011 22:23'!
initialize
	super initialize.
	! !

!RPSS_Administrator methodsFor: 'initialization' stamp: 'TimLenertz 10/25/2011 13:45'!
initializeWithEmail: em password: pw
	super initialize.
	email := em.
	password := pw.
	administrator := true.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 10:23'!
administrator: value
	administrator := value.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:59'!
confirmEmail
	^confirmEmail.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 12:00'!
confirmEmail: aConfirm
	confirmEmail := aConfirm.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:49'!
email
	^email.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:49'!
email: anEmail
	email := anEmail.! !

!RPSS_Visitor methodsFor: 'initialization' stamp: 'BogatchevOleg 10/21/2011 10:24'!
fromUser: anEmail
	|system user|
	system := RPSS_System uniqueInstance.
	user := system getUserWithEmail: anEmail.
	self email: user email.
	self password: user password.
	self administrator: user administrator.! !

!RPSS_Visitor methodsFor: 'initialization' stamp: 'BogatchevOleg 10/22/2011 16:39'!
initialize 
	super initialize.
	email := ''.
	password := ''.
	logedIn := false.
	administrator := false.
	confirmEmail := true.
	message := ''.
	module := nil.
	tempEmail := ''.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 10:22'!
isAdministrator
	^administrator.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/19/2011 14:38'!
isLogedIn
	^logedIn.! !

!RPSS_Visitor methodsFor: 'servicies' stamp: 'TimLenertz 10/26/2011 02:12'!
login: html
	|system|
	system := RPSS_System uniqueInstance.
	(system isUserAutorized: (self email) password: (self password))
	ifTrue: 
	[
		self fromUser: email.
		logedIn := true.
		self setModule: nil.
	]
	ifFalse: 
	[
		self setMessage: 'Wrong login/password or user not approved by administrator!!'.
	]. 
	! !

!RPSS_Visitor methodsFor: 'servicies' stamp: 'BogatchevOleg 10/22/2011 18:31'!
logout
	password := ''.
	email := ''.
	logedIn := false.
	administrator := false.
	message := ''.
	module := nil.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/19/2011 07:02'!
message
	^message.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/20/2011 23:08'!
module
	^module.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:50'!
password
	^password.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 11:50'!
password: aPassword
	password := aPassword.! !

!RPSS_Visitor methodsFor: 'rendering' stamp: 'BogatchevOleg 10/21/2011 10:19'!
renderContentOn: html
	html paragraph: 'To login, please provide the following information'.
	html 	form: 
			[
				html 	paragraph: 'Your e-mail adress:'.
				html 	textInput callback: [:value | self email: value].
				html 	paragraph: 'Your password:'.
				html 	textInput type: 'password'; callback: [:value | self password: value].
				html 	break.
				html 	submitButton callback: [ self login:html]; value: 'Login!!'.
			].! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/19/2011 07:03'!
setMessage: aMessage.
	message := aMessage.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/20/2011 23:08'!
setModule: aModule
	module := aModule.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 16:39'!
tempEmail
	^tempEmail.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 16:40'!
tempEmail: anEmail
	tempEmail := anEmail.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 18:14'!
tempPassword
	^tempPassword.! !

!RPSS_Visitor methodsFor: 'accessing' stamp: 'BogatchevOleg 10/22/2011 18:14'!
tempPassword: aPassword
	tempPassword := aPassword.! !

WASession subclass: #RPSS_Session
	instanceVariableNames: 'visitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_Session methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:47'!
user
	^ RPSS_System uniqueInstance getUserWithEmail: visitor email
	! !

!RPSS_Session methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:51'!
visitor
	visitor ifNil: [visitor := RPSS_Visitor new].
	^ visitor! !

!RPSS_Session methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:46'!
visitor: anObject
	visitor := anObject! !

Object subclass: #RPSS_CharacterClass
	instanceVariableNames: 'parent title attributes actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:27'!
actions
	^ actions! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:27'!
actions: anObject
	actions := anObject! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 22:39'!
attributeCollections
	|collections|
	collections := OrderedCollection new.
	attributes valuesDo: [:attribute |
		collections addIfNotPresent: attribute collection
	].
	^ collections! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 17:48'!
attributeName: attribute
	^ attributes keyAtValue: attribute! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/26/2011 01:59'!
attributeNames
	^ attributes keys asOrderedCollection.! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:46'!
attributes
	^ attributes! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:46'!
attributes: anObject
	attributes := anObject! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 22:48'!
attributesFromCollection: collection do: block
	attributes keysAndValuesDo: [:name :attribute |
		(attribute collection = collection) ifTrue: [
			block value: name value: attribute.
		] ifFalse: [].
	]! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/26/2011 01:50'!
inheritedAttributeCollections
	parent = nil
		ifTrue: [^ self attributeCollections]
		ifFalse: [^ self attributeCollections addAll: parent attributeCollections].! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/26/2011 01:50'!
inheritedAttributeNames
	parent = nil
		ifTrue: [^ self attributeNames]
		ifFalse: [^ self attributeNames addAll: parent attributeNames].! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/26/2011 01:50'!
inheritedAttributesFromCollection: collection do: block
	parent = nil ifFalse: [parent inheritedAttributesFromCollection: collection do: block] ifTrue: [].
	self attributesFromCollection: collection do: block! !

!RPSS_CharacterClass methodsFor: 'as yet unclassified' stamp: 'GeoffreyJacquet 10/26/2011 00:28'!
initialize
	title := 'New Character Class'.
	attributes := IdentityDictionary new.
	self actions: IdentityDictionary new.! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/26/2011 01:50'!
ownAttribute: name
	^ attributes keys includes: name! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/26/2011 01:51'!
parent
	^ parent! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/26/2011 01:51'!
parent: anObject
	parent := anObject! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:11'!
title
	^ title! !

!RPSS_CharacterClass methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 14:11'!
title: aString
	^ title := aString! !

Object subclass: #RPSS_CharacterClassAction
	instanceVariableNames: 'proba duration durationType prerequisites actionDelay trigger lastUsed cooldown effect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:35'!
actionDelay
	^ actionDelay! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:35'!
actionDelay: anObject
	actionDelay := anObject! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
cooldown
	^ cooldown! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
cooldown: anObject
	cooldown := anObject! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:29'!
duration
	^ duration! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:29'!
duration: anObject
	duration := anObject! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:29'!
durationType
	^ durationType! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:29'!
durationType: anObject
	durationType := anObject! !

!RPSS_CharacterClassAction methodsFor: 'as yet unclassified' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
initialize
	self actionDelay: 0.
	self cooldown: 0.
	self proba: nil.
	self durationType: 'Minutes'.
	self prerequisites: OrderedCollection new.! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:30'!
prerequisites
	^ prerequisites! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:30'!
prerequisites: anObject
	prerequisites := anObject! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:29'!
proba
	^ proba! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:29'!
proba: anObject
	proba := anObject! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:35'!
trigger
	^ trigger! !

!RPSS_CharacterClassAction methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:35'!
trigger: anObject
	trigger := anObject! !

Object subclass: #RPSS_CharacterClassActionPrerequisite
	instanceVariableNames: 'attributeName sign prerequisiteValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_CharacterClassActionPrerequisite methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
attributeName
	^ attributeName! !

!RPSS_CharacterClassActionPrerequisite methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
attributeName: anObject
	attributeName := anObject! !

!RPSS_CharacterClassActionPrerequisite methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
prerequisiteValue
	^ prerequisiteValue! !

!RPSS_CharacterClassActionPrerequisite methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
prerequisiteValue: anObject
	prerequisiteValue := anObject! !

!RPSS_CharacterClassActionPrerequisite methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
sign
	^ sign! !

!RPSS_CharacterClassActionPrerequisite methodsFor: 'accessing' stamp: 'GeoffreyJacquet 10/26/2011 00:36'!
sign: anObject
	sign := anObject! !

Object subclass: #RPSS_CharacterClassAttribute
	instanceVariableNames: 'collection initialValue modifiable random minValue maxValue formula maximumFormula'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 22:20'!
collection
	^ collection! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 22:20'!
collection: anObject
	collection := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 20:32'!
formula
	^ formula! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 20:32'!
formula: anObject
	formula := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
initialValue
	^ initialValue! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
initialValue: anObject
	initialValue := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 22:22'!
initialize
	collection := 'General'.
	formula := nil.
	initialValue := nil.
	maxValue := nil.
	maximumFormula := nil.
	minValue := nil.
	modifiable := true.
	random := false.! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
maxValue
	^ maxValue! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
maxValue: anObject
	maxValue := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 20:32'!
maximumFormula
	^ maximumFormula! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 20:32'!
maximumFormula: anObject
	maximumFormula := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
minValue
	^ minValue! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
minValue: anObject
	minValue := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
modifiable
	^ modifiable! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
modifiable: anObject
	modifiable := anObject! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
random
	^ random! !

!RPSS_CharacterClassAttribute methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 18:20'!
random: anObject
	random := anObject! !

Object subclass: #RPSS_Formula
	instanceVariableNames: 'operator operand1 operand2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 21:21'!
contract
	operator := operand1 operator.
	operand2 := operand1 operand2.
	operand1 := operand1 operand1.! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 21:22'!
expand
	operand1 := self copy.
	operator := '+'.
	operand2 := RPSS_Formula new.! !

!RPSS_Formula methodsFor: 'as yet unclassified' stamp: 'TimLenertz 10/25/2011 20:53'!
initialize
	operator := nil.
	operand1 := 0.
	operand2 := 0.! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 19:39'!
operand1
	^ operand1! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 19:39'!
operand1: anObject
	operand1 := anObject! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 19:39'!
operand2
	^ operand2! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 19:39'!
operand2: anObject
	operand2 := anObject! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 19:39'!
operator
	^ operator! !

!RPSS_Formula methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 19:39'!
operator: anObject
	operator := anObject! !

Object subclass: #RPSS_MailSender
	instanceVariableNames: 'emailFrom localhost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_MailSender class
	instanceVariableNames: 'uniqueInstance'!

RPSS_MailSender class
	instanceVariableNames: 'uniqueInstance'!

!RPSS_MailSender class methodsFor: 'instance destruction' stamp: 'BogatchevOleg 10/17/2011 17:27'!
reset
	uniqueInstance := nil.! !

!RPSS_MailSender class methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/17/2011 23:01'!
uniqueInstance
	uniqueInstance ifNil: 
	[
		uniqueInstance := self new.
	].
	^uniqueInstance.! !

!RPSS_MailSender methodsFor: 'initialization' stamp: 'BogatchevOleg 10/18/2011 21:06'!
initialize
	super initialize.
	emailFrom := 'rpss@ulb.ac.be'.
	localhost := WideString fromString: 'http://localhost:8080'.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:20'!
sendApprovalTo: anEmail
	self
		sendMail: 'You have been approved!!'
		subject: 'Email confirmation'
		to: anEmail.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:22'!
sendApprovalToAdmin: urlApp and: urlDen for: email
	|body linkApp linkDen administrator|
	
	linkApp := localhost, urlApp greaseString.
	linkDen := localhost, urlDen greaseString.
	administrator := (RPSS_System uniqueInstance) firstAdministrator.
	body := 'A new user created an account, please validate him, his email: ', email, ' to validate ',linkApp, ' to reject ', linkDen.
	
	self
		sendMail: body
		subject: 'Email confirmation'
		to: administrator email.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:23'!
sendDenialTo: anEmail
	self
		sendMail: 'You have been denied!!'
		subject: 'Email confirmation'
		to: anEmail.
! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:28'!
sendEmailChangeTo: anEmail with: newEmail url: aUrl
	|link body|
	link := localhost, aUrl greaseString.
	body := 'Please confirm that you want to change your mail from: ', anEmail, ' to ', newEmail,' with this link:', link.
	
	self
		sendMail: body
		subject: 'Email confirmation'
		to: anEmail.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:29'!
sendEmailConfirmationTo: anEmail withUrl: url
	|link body|
	link := localhost, url greaseString.
	body := 'You can confirm your email via this link: ', link.
	
	self
		sendMail: body
		subject: 'Email confirmation'
		to: anEmail.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:18'!
sendMail: body subject: subject to: receiver
	"Sends an email, using the SMTP configuration from the Seaside WAEmailConfiguration"
	
	|msg|
	msg := WAEmailMessage new.
	msg from: (WAEmailAddress address: emailFrom username: 'RPSS').
	msg addTo: (WAEmailAddress address: receiver username: receiver).
	msg subject: subject.
	msg body: (WAStringEmailBody string: body).
	msg send.! !

!RPSS_MailSender methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:30'!
sendPasswordChangeTo: anEmail url: aUrl
	|link body|
	link := localhost, aUrl greaseString.
	body := 'Please confirm that you want to change your password with this link:', link.
	
	self
		sendMail: body
		subject: 'Email confirmation'
		to: anEmail.! !

Object subclass: #RPSS_MailSenderOLD
	instanceVariableNames: 'emailFrom localhost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_MailSenderOLD class
	instanceVariableNames: 'uniqueInstance'!

RPSS_MailSenderOLD class
	instanceVariableNames: 'uniqueInstance'!

!RPSS_MailSenderOLD class methodsFor: 'instance destruction' stamp: 'TimLenertz 10/25/2011 10:05'!
reset
	uniqueInstance := nil.! !

!RPSS_MailSenderOLD class methodsFor: 'instance creation' stamp: 'TimLenertz 10/25/2011 10:05'!
uniqueInstance
	uniqueInstance ifNil: 
	[
		uniqueInstance := self new.
	].
	^uniqueInstance.! !

!RPSS_MailSenderOLD methodsFor: 'initialization' stamp: 'TimLenertz 10/25/2011 10:05'!
initialize
	super initialize.
	emailFrom := 'rpss@ulb.ac.be'.
	localhost := WideString fromString: 'http://localhost:8080'.! !

!RPSS_MailSenderOLD methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:05'!
sendApprovalTo: anEmail
	|msg to from subject body bodyhtml content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	bodyhtml := 'You have been approved!! '.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSenderOLD methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:05'!
sendApprovalToAdmin: urlApp and: urlDen for: email
	|msg to from subject body bodyhtml content administrator linkApp linkDen|
	administrator := (RPSS_System uniqueInstance) firstAdministrator.
	
	to := MIMEHeaderValue forField: 'to' fromString: administrator email.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	linkApp := localhost, urlApp greaseString.
	linkDen := localhost, urlDen greaseString.
	bodyhtml := 'A new user created an account, please validate him, his email: ', email, ' to validate ',linkApp, ' to reject ', linkDen.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSenderOLD methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:05'!
sendDenialTo: anEmail
	|msg to from subject body bodyhtml content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	bodyhtml := 'You have been denied!! '.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSenderOLD methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:05'!
sendEmailChangeTo: anEmail with: newEmail url: aUrl
	|msg to from subject body bodyhtml link content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	link := localhost, aUrl greaseString.
	bodyhtml := 'Please confirm that you want to change your mail from: ', anEmail, ' to ', newEmail,' with this link:', link.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSenderOLD methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:05'!
sendEmailConfirmationTo: anEmail withUrl: url
	|msg to from subject body bodyhtml link content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	link := localhost, url greaseString.
	bodyhtml := 'You can confirm your email via this link: ', link.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

!RPSS_MailSenderOLD methodsFor: 'services' stamp: 'TimLenertz 10/25/2011 10:05'!
sendPasswordChangeTo: anEmail url: aUrl
	|msg to from subject body bodyhtml link content|
	to := MIMEHeaderValue forField: 'to' fromString: anEmail.
	from := MIMEHeaderValue forField: 'from' fromString: emailFrom.
	content := MIMEHeaderValue forField: 'content' fromString: 'text/html'.
	subject := MIMEHeaderValue fromTraditionalHeader:  'Email confirmation'.
	
	link := localhost, aUrl greaseString.
	bodyhtml := 'Please confirm that you want to change your password with this link:', link.
	body := MIMEDocument contentType: 'text/html' content: bodyhtml.
	
	msg := (MailMessage new setField: 'to' to: to;
	setField: 'from' to: from;
	setField: 'subject' to: subject;
	setField: 'content' to: content;
	body: body yourself).
	(MailComposition new sendMailMessage: msg) submit.! !

Object subclass: #RPSS_System
	instanceVariableNames: 'collection initialized emailConfRequired userApprovedByAdmin firstAdministrator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

RPSS_System class
	instanceVariableNames: 'uniqueInstance'!

RPSS_System class
	instanceVariableNames: 'uniqueInstance'!

!RPSS_System class methodsFor: 'instance destruction' stamp: 'BogatchevOleg 10/19/2011 07:58'!
reset
	uniqueInstance := nil.
	RPSS_MailSender reset.! !

!RPSS_System class methodsFor: 'instance destruction' stamp: 'TimLenertz 10/25/2011 14:15'!
resetWithAdministrator: email password: password
	|user|
	user := (RPSS_User new fromVisitor: (RPSS_Administrator new initializeWithEmail: email password: password)).
	user approveByAdministrator.
	RPSS_System reset.
	RPSS_System uniqueInstance
		addUser: user;
		setFirstAdministrator: user;
		finishInitialization. 
	
 ! !

!RPSS_System class methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/17/2011 15:15'!
uniqueInstance
	uniqueInstance ifNil: [uniqueInstance := self new].
	^uniqueInstance.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/17/2011 15:17'!
addUser: aUser
	collection at: (((aUser email) onlyLetters ) asSymbol ) put: aUser.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/21/2011 16:45'!
approveUser: anEmail
	|user mail|
	(self isEmailOccupied: anEmail)
	ifTrue: 
	[
		user := self getUserWithEmail: anEmail.
		mail := RPSS_MailSender uniqueInstance.
		user approveByAdministrator.
		mail sendApprovalTo: anEmail.
	].! !

!RPSS_System methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:06'!
collection
	"Collection of RPSS_User objects"
	
	^collection.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/21/2011 22:20'!
denyUser: anEmail
	|mail user|
	mail := RPSS_MailSender uniqueInstance.
	(self isEmailOccupied: anEmail)
	ifTrue: 
	[
		collection removeKey: ((anEmail onlyLetters ) asSymbol ).
		mail sendDenialTo: anEmail.
	].! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:56'!
finishInitialization
	initialized := true.! !

!RPSS_System methodsFor: 'select' stamp: 'BogatchevOleg 10/19/2011 20:01'!
firstAdministrator
	^firstAdministrator.! !

!RPSS_System methodsFor: 'select' stamp: 'BogatchevOleg 10/21/2011 16:14'!
getUserWithEmail: anEmail
	^(collection at: ((anEmail) onlyLetters) asSymbol).! !

!RPSS_System methodsFor: 'initialization' stamp: 'BogatchevOleg 10/19/2011 20:01'!
initialize
	super initialize.
	collection := IdentityDictionary new.
	initialized := false.
	emailConfRequired := true.
	userApprovedByAdmin := true.
	firstAdministrator := nil.! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 15:17'!
isEmailConfRequired
	^emailConfRequired.! !

!RPSS_System methodsFor: 'testing' stamp: 'BogatchevOleg 10/18/2011 21:23'!
isEmailOccupied: anEmail
	^(collection includesKey:  (((anEmail) onlyLetters ) asSymbol )).! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:47'!
isInitialized 
	^initialized.! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:49'!
isUserApprovedByAdmin
	^userApprovedByAdmin.! !

!RPSS_System methodsFor: 'testing' stamp: 'BogatchevOleg 10/21/2011 16:09'!
isUserAutorized: anEmail password: aPassword
	|user|
	(collection includesKey: ((anEmail onlyLetters ) asSymbol))
	ifTrue: 
	[
		user := self getUserWithEmail: anEmail.
		((user password = aPassword) & (user approvedByAdministrator = true)) 
		ifTrue: 
		[
			^true.
		].
	].
	^false.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/19/2011 20:03'!
setFirstAdministrator: newAdministrator
	^firstAdministrator := newAdministrator.! !

!RPSS_System methodsFor: 'operations' stamp: 'BogatchevOleg 10/22/2011 17:09'!
transferUserFrom: anEmail to: newEmail
	|user|
	user := self getUserWithEmail: anEmail.
	collection removeKey: (((anEmail) onlyLetters) asSymbol).
	collection at: (((newEmail) onlyLetters) asSymbol) put: user.
	user email: newEmail.


	! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:47'!
userApprovedByAdmin
	^userApprovedByAdmin.! !

!RPSS_System methodsFor: 'accessing' stamp: 'BogatchevOleg 10/17/2011 17:48'!
userApprovedByAdmin: newValue
	userApprovedByAdmin := newValue.! !

!RPSS_System methodsFor: 'select' stamp: 'BogatchevOleg 10/21/2011 23:00'!
usersToApprove
	^collection select: [:user | user isNotApprovedByAdministrator & user isEmailConfirmed ]! !

!RPSS_System methodsFor: 'servicies' stamp: 'BogatchevOleg 10/17/2011 19:16'!
verifyEmail: anEmail
	^true.! !

!RPSS_System methodsFor: 'servicies' stamp: 'BogatchevOleg 10/17/2011 19:16'!
verifyPassword: aPassword
	^true.! !

Object subclass: #RPSS_User
	instanceVariableNames: 'email password administrator emailConfirmed approvedByAdministrator characterClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPSS'!

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:19'!
administrator
	^administrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:19'!
administrator: value
	administrator := value.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:14'!
approveByAdministrator
	approvedByAdministrator := true.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 16:09'!
approvedByAdministrator
	^approvedByAdministrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:10'!
approvedByAdministrator: anObject
	approvedByAdministrator := anObject! !

!RPSS_User methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:10'!
characterClasses
	^ characterClasses! !

!RPSS_User methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:10'!
characterClasses: anObject
	characterClasses := anObject! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
email
	^email.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
email: anEmail
	email := anEmail.! !

!RPSS_User methodsFor: 'accessing' stamp: 'TimLenertz 10/25/2011 12:10'!
emailConfirmed: anObject
	^ emailConfirmed := anObject! !

!RPSS_User methodsFor: 'instance creation' stamp: 'BogatchevOleg 10/19/2011 16:50'!
fromVisitor: aVisitor
	email := aVisitor email.
	password := aVisitor password.
	administrator := false.
	emailConfirmed := false.
	approvedByAdministrator := false.! !

!RPSS_User methodsFor: 'initialization' stamp: 'TimLenertz 10/25/2011 12:10'!
initialize
	super initialize.
	email := ''.
	password := ''.
	emailConfirmed := false.
	approvedByAdministrator := false.
	characterClasses := OrderedCollection new.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/19/2011 19:58'!
isAdministrator
	^administrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 22:46'!
isApprovedByAdministrator
	^approvedByAdministrator.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 22:45'!
isEmailConfirmed
	^emailConfirmed.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/21/2011 22:47'!
isNotApprovedByAdministrator
	^(approvedByAdministrator not).! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:13'!
markAsAdministrator
	administrator := true.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:14'!
markEmailConfirmed
	^emailConfirmed := true.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
password
	^password.! !

!RPSS_User methodsFor: 'accessing' stamp: 'BogatchevOleg 10/18/2011 21:12'!
password: aPassword
	password := aPassword.! !
